VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCDROM"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit                         ' explicit parsing

#Const doDebug = 0

'////////////////////////////////////\
'/////////////////////// functions   //=>>>
'/////////////////////////////////////

Private Declare Function DeviceIoControl Lib "kernel32" ( _
    ByVal hDevice As Long, ByVal dwIoControlCode As Long, _
    ByRef lpInBuffer As Any, ByVal nInBufferSize As Long, _
    ByRef lpOutBuffer As Any, ByVal nOutBufferSize As Long, _
    ByRef lpBytesReturned As Long, ByRef lpOverlapped As t_OVERLAPPED _
) As Long

Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" ( _
    ByVal lpFileName As String, ByVal dwDesiredAccess As Long, _
    ByVal dwShareMode As Long, lpSecurityAttributes As Any, _
    ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, _
    hTemplateFile As Long _
) As Long

Private Declare Function CloseHandle Lib "kernel32" ( _
    ByVal hObject As Long _
) As Long

Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" ( _
    ByVal nDrive As String _
) As Long

Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" ( _
        lpVersionInformation As OSVERSIONINFOEX _
) As Long

'--- by Paul Caton -----------------------------------------------|
Private Declare Sub RtlMoveMemory Lib "kernel32" ( _
    Destination As Any, Source As Any, ByVal Length As Long _
)

'------------------------------------------------------------------|

'////////////////////////////////////\
'/////////////////////// structures  //=>>>
'/////////////////////////////////////

Private Type t_SCSI_ADDRESS
    Length            As Long     ' data len
    PortNumber        As Byte     ' Host Adapter
    PathId            As Byte     ' ?
    TargetID          As Byte     ' Target
    LUN               As Byte     ' Logical Unit Number
End Type

Private Type t_OVERLAPPED
    Internal          As Long     '
    InternalHigh      As Long     '
    offset            As Long     '
    OffsetHigh        As Long     '
    hEvent            As Long     '
End Type

Private Type t_HAID
    HA                As Byte     ' Host Adapter
    ID                As Byte     ' Target
End Type

Private Type t_InqDat
    PDT               As Byte     ' drive type
    PDQ               As Byte     ' removable drive
    VER               As Byte     ' MMC Version (zero for ATAPI)
    RDF               As Byte     ' interface depending field
    DLEN              As Byte     ' additional len
    rsv1(1)           As Byte     ' reserved
    Feat              As Byte     ' ?
    VID(7)            As Byte     ' vendor
    PID(15)           As Byte     ' Product
    PVER(3)           As Byte     ' revision (= Firmware Version)
    FWVER(20)         As Byte     ' ?
End Type

Private Type OSVERSIONINFOEX
    dwOSVersionInfoSize As Long   ' data len
    dwMajorVersion      As Long   ' Windows Major Version
    dwMinorVersion      As Long   ' Windows Minor Version
    dwBuildNumber       As Long   ' Windows Build Number
    dwPlatformId        As Long   ' Windows Platform Identifier
    szCSDVersion        As String * 128 ' Windows Version as a string
End Type

Private Type t_SPTD
    Length             As Integer ' data len
    ScsiStatus         As Byte    ' SCSI Status
    PathId             As Byte    ' Bus Number
    TargetID           As Byte    ' Target
    LUN                As Byte    ' Logical Unit Number
    CdbLength          As Byte    ' CDB (Command Descriptor Block)
    SenseInfoLength    As Byte    ' Sense Info len
    DataIn             As Byte    ' data direction
    DataTransferLength As Long    ' data transfer length
    TimeOutValue       As Long    ' command timeout
    DataBuffer         As Long    ' Pointer to the data buffer
    SenseInfoOffset    As Long    ' Sense Info Offset
    cdb(15)            As Byte    ' Command Descriptor Block
    Fill(2)            As Byte    '
End Type

Private Type t_SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER
    SPT             As t_SPTD     ' SPTD structure
    'Fill(3)         As Byte       '
    SenseBuffer(35) As Byte       ' Debugging-Info from the drive
End Type

'/////////////////////////////////////\
'/////////////////////// enumerations //=>>>
'//////////////////////////////////////

Public Enum e_SPTIDirection
    SCSI_IOCTL_DATA_OUT = 0           ' send data to the drive
    SCSI_IOCTL_DATA_IN = 1            ' retrieve data from the drive
    SCSI_IOCTL_DATA_UNSPECIFIED = 2   ' no transfer
End Enum

Public Enum e_AspiDirection
    SRB_DIR_IN = &H8              ' retrieve data from the drive
    SRB_DIR_OUT = &H10            ' send data to the drive
End Enum

Public Enum e_Inquiry
    vendor = &H1                  ' return vendor
    product = &H2                 ' return product id
    revision = &H4                ' return revision
End Enum

Public Enum e_Interfaces
    spti = 2
End Enum

'/////////////////////////////////////\
'/////////////////////// constants    //=>>>
'//////////////////////////////////////

Private Const IOCTL_SCSI_BASE       As Long = &H4        '

Private Const METHOD_BUFFERED       As Long = &H0        '
Private Const METHOD_IN_DIRECT      As Long = &H1        '
Private Const METHOD_OUT_DIRECT     As Long = &H2        '
Private Const METHOD_NEITHER        As Long = &H3        '

Private Const FILE_ANY_ACCESS       As Long = &H0        ' full access
Private Const FILE_READ_ACCESS      As Long = &H1        ' read access
Private Const FILE_WRITE_ACCESS     As Long = &H2        ' write access

Private Const INVALID_HANDLE_VALUE  As Long = -1         ' invalid handle
Private Const OPEN_EXISTING         As Long = &H3        ' open existing
Private Const GENERIC_READ          As Long = &H80000000 ' generic read rights
Private Const GENERIC_WRITE         As Long = &H40000000 ' generic write right
Private Const FILE_SHARE_READ       As Long = &H1        ' shared read rights
Private Const FILE_SHARE_WRITE      As Long = &H2        ' shared write right
Private Const FILE_ATTRIBUTE_NORMAL As Long = &H80       ' ?

Private Const VER_PLATFORM_WIN32_NT As Long = &H2        ' Windows NT 3/4/2000/XP/Longhorn

Private IOCTL_SCSI_PASS_THROUGH_DIRECT As Long           ' DevIoCtl Code
Private IOCTL_SCSI_PASS_THROUGH        As Long           ' DevIoCtl Code
Private IOCTL_SCSI_GET_ADDRESS         As Long           ' DevIoCtl Code


'--- by Paul Caton ----------------------------------------
Private Const CODE_CDECL    As String = "538B5C240C8B0BE305FF348BE2FBE8<fix 01>8B0BC1E10201CC5B8B54240C890231C0C20C00"
Private Const CODE_WRAPPER  As String = "E8000000005A8F4219E8<fix 02>81EC<fix 03>E8000000005AFF7205C300000000"

'-----------------------------------------------------------


'///////////////////////////////////\
'/////////////////////// variables  //=>>>
'////////////////////////////////////

Private blnW2K        As Boolean                         ' >= Windows 2000?

Private lngPower2(31) As Long                            ' bit shifting values

Private lngHandles(25) As Long

Private intLastSK     As Integer
Private intLastASC    As Integer
Private intLastASCQ   As Integer

Private Init          As Boolean

'--- by Paul Cation -----------------------------
Private pMe                 As Long                      ' vtable address
Private nEntry              As Long                      ' vtable entry index
Private pCode               As Long                      ' Pointer to the CDECL code
Private sCode()             As String                    ' Code buffer string array...

'Convert the passed string of hex character pairs to bytes stored in an ASCII
'string buffer. If indicated, patch the appropriate vtable entry to point to the byte codes
Private Sub Redirect(ByVal sHexCode As String, ByVal bPatch As Boolean)
  Dim i     As Long
  Dim nLen  As Long
  Dim s     As String
  
  nLen = Len(sHexCode)
  
  For i = 1 To nLen Step 2
    s = s & ChrB$(Val("&H" & Mid$(sHexCode, i, 2)))
  Next i
  
  ReDim Preserve sCode(0 To nEntry)
  sCode(nEntry) = s
  
  If bPatch Then
    'Patch the vtable entry to point to the code
    Call RtlMoveMemory(ByVal pMe + &H1C + (nEntry * 4), StrPtr(sCode(nEntry)), 4)
  End If
  
  nEntry = nEntry + 1                               'In case another patch is added to the class
End Sub

'This sub is replaced by machine code in sCode(0) at class instance creation...
'IT MUST ONLY be called internally by CallFunc. It can't be made Private as it wouldn't
'then use the vtable. Being the first public method in this class, we know that the vtable
'pointer to this function will be located at [vtable + &H1C]
Public Function z_DO_NOT_CALL(ByVal nAddrParamBlock As Long) As Long
End Function

'-------------------------------------------------

'read CD/DVD-ROM drive name with inquiry
Public Function CDROMGetName(ByVal strDrvID As String, _
                             ByVal flags As e_Inquiry) As String

    Dim inq     As t_InqDat     ' Inquiry structure
    Dim cmd(5)  As Byte         ' CDB

    cmd(0) = &H12               ' 0x12 Inquiry (6 Byte)
    cmd(4) = Len(inq) - 1       ' allocation length

    'execute the command (inquiry needs to be supported by every CD/DVD-ROM)
    ExecCMD strDrvID, cmd, 6, True, SRB_DIR_IN, VarPtr(inq), Len(inq)

    'return vendor
    If flags And vendor Then _
        CDROMGetName = StrConv(inq.VID, vbUnicode)

    'return product ID
    If flags And product Then _
        CDROMGetName = CDROMGetName & StrConv(inq.PID, vbUnicode)

    'return revision
    If flags And revision Then _
        CDROMGetName = CDROMGetName & StrConv(inq.PVER, vbUnicode)

End Function

'drive is CD/DVD-ROM?
Public Function IsCDROM(ByVal strDrv As String) As Boolean
    IsCDROM = GetDriveType(Left$(strDrv, 1) & ":") = 5
End Function

' last sense key
Public Property Get LastSK() As Integer
    LastSK = intLastSK
End Property

' last additional sense code
Public Property Get LastASC() As Integer
    LastASC = intLastASC
End Property

' last additional sense code qualifier
Public Property Get LastASCQ() As Integer
    LastASCQ = intLastASCQ
End Property

'choose an interface
Public Function ChooseInterface() As Boolean

    'SPTI available?
    If SPTIAvailable Then
        ChooseInterface = True
    End If

End Function

'return the currently used interface
Public Function CurrentInterface() As e_Interfaces

    CurrentInterface = e_Interfaces.spti

End Function

'test supported interfaces
Public Function InterfaceAvailable(ByVal i As e_Interfaces) As Boolean

    Select Case i
        Case spti
            InterfaceAvailable = SPTIAvailable
    End Select

End Function

'SPTI available?
Private Function SPTIAvailable() As Boolean

    Dim pswb As t_SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER, ol As t_OVERLAPPED
    Dim Length As Long, returned As Long, i As Long
    Dim Status As Long, fh As Long
    Dim drv As String

    'find the first CD/DVD-ROM drive
    For i = 1 To 26
        If GetDriveType(Chr$(i + 64) & ":") = 5 Then
            drv = Chr$(i + 64)
            Exit For
        End If
    Next

    'get its drive handle
    If Not GetDriveHandle(drv, fh) Then Exit Function

    With pswb.SPT
        '.SenseInfoOffset = Len(pswb.spt) + 4               ' Sense Info Offset
        .SenseInfoLength = UBound(pswb.SenseBuffer) - 4     ' Sense Info size
        .SenseInfoOffset = VarPtr(pswb.SenseBuffer(0)) - VarPtr(pswb)
        .DataIn = SCSI_IOCTL_DATA_IN                       ' data direction
        .TimeOutValue = 10                                 ' Timeout
        .CdbLength = 6                                     ' CDB length
        .Length = 44                                       ' size of the substructure
    End With
    Length = Len(pswb)                                     ' size of the structure

    'SPTD (SCSI Pass-Through Direct, need admin priviledges)
    Status = DeviceIoControl(fh, IOCTL_SCSI_PASS_THROUGH_DIRECT, _
                             pswb, Length, pswb, Length, _
                             returned, ol)

    'CloseHandle fh

    'success?
    SPTIAvailable = Status = 1

End Function

'get a drive's handle
Private Function GetDriveHandle(ByVal drv As String, ByRef fh As Long) As Boolean

    Dim flags   As Long, i   As Integer

    ' function already called?
    If Not Init Then

        ' no, get the handles for every CD/DVD-ROM

        ' starting from win 2k you also need GENERIC_WRITE
        flags = GENERIC_READ
        If blnW2K Then flags = flags Or GENERIC_WRITE

        For i = 1 To 26

            If GetDriveType(Chr$(i + 64) & ":") = 5 Then

                    ' get the handle with CreateFile().
                    ' you can access drives with "\\.\X:", where X is the drive's char.
                    fh = CreateFile("\\.\" & Chr$(i + 64) & ":", flags, _
                                    FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0, _
                                    OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, ByVal 0)

                    lngHandles(i - 1) = fh

            Else

                ' not a CD/DVD-ROM drive
                lngHandles(i - 1) = -1

            End If

        Next

        ' initialized
        Init = True

    End If

    ' return drive handle
    fh = lngHandles(Asc(UCase$(drv)) - 65)

    GetDriveHandle = fh <> -1

End Function

'execute a command through the SPTI
Private Function SPTICmd(ByVal drv As String, ByRef cmd() As Byte, _
                         ByVal CmdLen As Integer, ByVal WFE As Boolean, _
                         ByVal eDir As e_SPTIDirection, ByVal Pointer As Long, _
                         ByVal PointerLen As Long, Optional ByVal timeout As Long = 5 _
                        ) As Boolean

    Dim pswb As t_SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER, ol As t_OVERLAPPED
    Dim Length As Long, returned As Long, i As Long
    Dim Status As Long, fh As Long

    'get the drive's handle
    If Not GetDriveHandle(drv, fh) Then Exit Function

    'check the timeout
    If WFE Then timeout = 9999 Else If timeout = 0 Then timeout = 10

    With pswb.SPT

        .Length = 44                                       ' size of the substructure

        .DataIn = eDir                                     ' data dir

        .TimeOutValue = timeout                            ' Timeout

        .SenseInfoLength = UBound(pswb.SenseBuffer) - 4    ' Sense Info size
        .SenseInfoOffset = Len(pswb.SPT) + 4               ' Sense Info Offset
        '.SenseInfoOffset = VarPtr(pswb.SenseBuffer(0)) - VarPtr(pswb)

        .DataTransferLength = PointerLen                   ' data len
        .DataBuffer = Pointer                              ' data buffer pointer

        For i = 0 To CmdLen - 1: .cdb(i) = cmd(i): Next i  ' CDB from Array
        .CdbLength = CmdLen                                ' CDB len

    End With

    Length = Len(pswb)                                     ' size of the structure

    'SPTD
    Status = DeviceIoControl(fh, IOCTL_SCSI_PASS_THROUGH_DIRECT, _
                             pswb, Length, pswb, Length, _
                             returned, ol)

    'close the drive's handle
    'CloseHandle fh

    'success?
    SPTICmd = Status = 1 And pswb.SPT.ScsiStatus = 0

    intLastSK = pswb.SenseBuffer(2) And &HF
    intLastASC = pswb.SenseBuffer(12)
    intLastASCQ = pswb.SenseBuffer(13)

'###########################################
    #If doDebug Then
        Debug.Print "###### SPTI CMD ######"
        Debug.Print "======================"
        Debug.Print "SCSI Status: " & Hex$(pswb.SPT.ScsiStatus) & "h"
        Debug.Print "CDB: ";
        For i = 0 To pswb.SPT.CdbLength - 1
            Debug.Print format(Hex$(pswb.SPT.cdb(i)), "00") & " ";
        Next
        Debug.Print ""
        Debug.Print "Direction: " & pswb.SPT.DataIn
        Debug.Print "Data len: " & pswb.SPT.DataTransferLength
        Debug.Print "SK: " & intLastSK
        Debug.Print "ASC: " & intLastASC
        Debug.Print "ASCQ: " & intLastASCQ
    #End If
'###########################################

End Function

'An instruction over an interface implement
Public Function ExecCMD(ByVal DrvID As String, ByRef cmd() As Byte, _
                        ByVal CmdLen As Integer, ByVal WFE As Boolean, _
                        ByVal eDir As e_AspiDirection, ByVal BufPtr As Long, _
                        ByVal buflen As Long, Optional ByVal timeout As Long = 5 _
                       ) As Boolean

    Dim DataDir As Long

    'SPTI
    DataDir = Choose(Abs(CBool(eDir = SRB_DIR_IN)) + 1, _
                     SCSI_IOCTL_DATA_OUT, SCSI_IOCTL_DATA_IN)

    ExecCMD = SPTICmd(DrvID, cmd, CmdLen, WFE, DataDir, BufPtr, buflen, timeout)

End Function

'convert drive ID to drive char
Public Function DrvChrFromDrvID(ByVal strDrvID As String) As String

    DrvChrFromDrvID = strDrvID

End Function

'HA:ID from drive char
Public Function HAIDFromDrvChr(ByVal strDrv As String) As String

    Dim haid As t_HAID

    If SPTIGetHAID(strDrv, haid) Then
        With haid
            HAIDFromDrvChr = Chr$(.HA) & Chr$(.ID)
        End With
    End If

End Function

'HA:ID from drive char (NT/2K/XP)
Private Function SPTIGetHAID(ByVal strDrv As String, ByRef haid As t_HAID) As Boolean

    Dim returned    As Long, Status As Long
    Dim fh          As Long
    
    Dim pscsiAddr   As t_SCSI_ADDRESS
    Dim ol          As t_OVERLAPPED


    'get drive handle
    If GetDriveHandle(Left$(strDrv, 1), fh) Then

        'get SCSI address
        pscsiAddr.Length = Len(pscsiAddr)
        Status = DeviceIoControl(fh, IOCTL_SCSI_GET_ADDRESS, _
                                 pscsiAddr, Len(pscsiAddr), _
                                 pscsiAddr, Len(pscsiAddr), _
                                 returned, ol)

        'CloseHandle fh

        'success?
        If Status = 1 Then
            With pscsiAddr
                haid.HA = .PortNumber
                haid.ID = .TargetID
                SPTIGetHAID = True
                Exit Function
            End With
        End If

    End If

End Function

'calculate control code
Private Function CTL_CODE(ByVal lDevType As Long, ByVal lFunction As Long, _
                          ByVal lMethod As Long, ByVal lAccess As Long) As Long

    CTL_CODE = LShift(lDevType, 16) Or LShift(lAccess, 14) Or _
               LShift(lFunction, 2) Or lMethod

End Function

Private Sub Class_Initialize()

    Dim osver As OSVERSIONINFOEX

    osver.dwOSVersionInfoSize = Len(osver)  ' structure size
    GetVersionEx osver                      ' get windows version

    'is >= Win 2K?
    If osver.dwPlatformId = VER_PLATFORM_WIN32_NT Then _
        blnW2K = osver.dwMajorVersion >= 5

    'SPTD Control Code
    IOCTL_SCSI_PASS_THROUGH_DIRECT = CTL_CODE(IOCTL_SCSI_BASE, &H405, _
                                              METHOD_BUFFERED, _
                                              FILE_READ_ACCESS Or FILE_WRITE_ACCESS)

    'SPT Control Code
    IOCTL_SCSI_PASS_THROUGH = CTL_CODE(IOCTL_SCSI_BASE, &H401, _
                                       METHOD_BUFFERED, _
                                       FILE_READ_ACCESS Or FILE_WRITE_ACCESS)

    'SGA Control Code
    IOCTL_SCSI_GET_ADDRESS = CTL_CODE(IOCTL_SCSI_BASE, &H406, _
                                      METHOD_BUFFERED, FILE_ANY_ACCESS)

    
    '--- by Paul Caton ---------------------------
    
    'ObjPtr returns the address of me, at that address is the address of the vtable, copy it to pMe.
    Call RtlMoveMemory(pMe, ByVal ObjPtr(Me), 4)

    'Replace the stub proc (z_DO_NOT_CALL) with machine-code to handle the cdecl function
    'stored in sCode(0). Load the wrapper code into sCode(1)
    Call Redirect(CODE_CDECL, True)          ' CDECL code
    pCode = StrPtr(sCode(0))                 ' Remember the address of the CDECL code

    Call Redirect(CODE_WRAPPER, False)       ' Callback wrapper code, vtable not patched... we don't call it
    '----------------------------------------------
End Sub

Public Sub Goodbye()
    Class_Terminate
End Sub

Private Sub Class_Terminate()

    Dim i   As Long

    For i = 0 To 25
        CloseHandle lngHandles(i)
    Next

    Init = False
    
End Sub

'is a bit in a byte set?
Public Function IsBitSet(ByVal InByte As Byte, ByVal Bit As Byte) As Boolean
    IsBitSet = ((InByte And (2 ^ Bit)) > 0)
End Function

'MSF to LBA
Public Function MSF2LBA(ByVal mins As Long, ByVal secs As Long, _
                        ByVal frames As Long, _
                        Optional positive As Boolean) As Long

    MSF2LBA = (mins * 60& + secs) * 75& + frames

    If mins < 90 Or positive Then
        MSF2LBA = MSF2LBA - 150
    Else
        MSF2LBA = MSF2LBA - 450150
    End If

End Function

'LBA to MSF
Public Function LBA2MSF(ByVal LBA As Long) As String

    Dim M As Long, s As Long, F As Long, start As Long

    start = Choose(Abs(CBool(LBA >= -150)) + 1, 450150, 150)

    M = Fix((LBA + start) / (60 * 75))
    s = Fix((LBA + start - M * 60 * 75) / 75)
    F = Fix(LBA + start - M * 60 * 75 - s * 75)

    LBA2MSF = format(M, "00") & ":" & format(s, "00") & ":" & format(F, "00")

End Function

'>> Operator for VB
'by VB-Accelerator
Public Function RShift(ByVal lThis As Long, ByVal lBits As Long) As Long

   Static Init As Boolean

   If Not Init Then InitShifting: Init = True

   If (lBits <= 0) Then
      RShift = lThis
   ElseIf (lBits > 63) Then
      Exit Function
   ElseIf (lBits > 31) Then
      RShift = 0
   Else
      If (lThis And lngPower2(31)) = lngPower2(31) Then
         RShift = (lThis And &H7FFFFFFF) \ lngPower2(lBits) Or lngPower2(31 - lBits)
      Else
         RShift = lThis \ lngPower2(lBits)
      End If
   End If

End Function

'<< Operator for VB
'by VB-Accelerator
Public Function LShift(ByVal lThis As Long, ByVal lBits As Long) As Long

   Static Init As Boolean

   If Not Init Then InitShifting: Init = True

   If (lBits <= 0) Then
      LShift = lThis
   ElseIf (lBits > 63) Then
      Exit Function
   ElseIf (lBits > 31) Then
      LShift = 0
   Else
      If (lThis And lngPower2(31 - lBits)) = lngPower2(31 - lBits) Then
         LShift = (lThis And (lngPower2(31 - lBits) - 1)) * lngPower2(lBits) Or lngPower2(31)
      Else
         LShift = (lThis And (lngPower2(31 - lBits) - 1)) * lngPower2(lBits)
      End If
   End If

End Function

'Shifting values
'by VB-Accelerator
Private Sub InitShifting()
   lngPower2(0) = &H1&: lngPower2(1) = &H2&: lngPower2(2) = &H4&
   lngPower2(3) = &H8&: lngPower2(4) = &H10&: lngPower2(5) = &H20&
   lngPower2(6) = &H40&: lngPower2(7) = &H80&: lngPower2(8) = &H100&
   lngPower2(9) = &H200&: lngPower2(10) = &H400&: lngPower2(11) = &H800&
   lngPower2(12) = &H1000&: lngPower2(13) = &H2000&: lngPower2(14) = &H4000&
   lngPower2(15) = &H8000&: lngPower2(16) = &H10000: lngPower2(17) = &H20000
   lngPower2(18) = &H40000: lngPower2(19) = &H80000: lngPower2(20) = &H100000
   lngPower2(21) = &H200000: lngPower2(22) = &H400000: lngPower2(23) = &H800000
   lngPower2(24) = &H1000000: lngPower2(25) = &H2000000: lngPower2(26) = &H4000000
   lngPower2(27) = &H8000000: lngPower2(28) = &H10000000: lngPower2(29) = &H20000000
   lngPower2(30) = &H40000000: lngPower2(31) = &H80000000
End Sub
