Attribute VB_Name = "modIP"
Option Explicit

Public Sub ReadIP(ByVal sFile As String, src As enm_Source, Optional meta As String)
    
On Error GoTo ErrorHandler

    Dim strExtension        As String
    Dim strChunk            As String
    Dim sMetaInfo           As String
    Dim PercentDone         As Double
    Dim lngByteBuffer       As Long
    Dim lngBytesRemain      As Long
    Dim lngByteIP           As Long
    Dim lngByteIP0000       As Long
    Dim iBinSector          As Integer
    Dim i                   As Integer

    Select Case src
    
        '//
        '// CD IMAGE
        '//
        Case SOURCE_CDIMAGE
            strExtension = JustExt$(sFile)
            
            'check supported extensions
            If strExtension <> "img" And _
               strExtension <> "mdf" And _
               strExtension <> "bin" And _
               strExtension <> "cdi" And _
               strExtension <> "nrg" And _
               strExtension <> "iso" And _
               strExtension <> "tao" And _
               strExtension <> "cdp" Then
                'not a supported extension
                If MsgBox("There is no specific support for this file extension but you" & vbCrLf & _
                          "can try reading the CD image anyway. Do you want to" & vbCrLf & _
                          "continue?", vbYesNo Or vbExclamation, "Warning") = vbNo Then
                    Exit Sub
                End If
                'select sector size
                frmSectorSize.Show vbModal
                If frmSectorSize.Canceled = True Then Exit Sub
            End If
            
            'detect sector size for *.bin
            If strExtension = "bin" Then
                Open sFile For Binary As #1
                    Dim btSyncData(11) As Byte
                    ReDim btBuffer(11) As Byte
                    Get #1, 1, btBuffer()
                    btSyncData(0) = &H0
                    btSyncData(1) = &HFF
                    btSyncData(2) = &HFF
                    btSyncData(3) = &HFF
                    btSyncData(4) = &HFF
                    btSyncData(5) = &HFF
                    btSyncData(6) = &HFF
                    btSyncData(7) = &HFF
                    btSyncData(8) = &HFF
                    btSyncData(9) = &HFF
                    btSyncData(10) = &HFF
                    btSyncData(11) = &H0
                    For i = 0 To 11
                        If btBuffer(i) <> btSyncData(i) Then
                            iBinSector = 288
                            Exit For 'exit loop on difference
                        Else
                            iBinSector = 304
                        End If
                    Next
                Close #1
            End If
            
            'set ECC size
            Select Case strExtension
                Case "bin": lngBytesOfECC = iBinSector
                Case "img", "mdf", "cdp": lngBytesOfECC = 304
                Case "cdi", "nrg": lngBytesOfECC = 288
                Case "iso", "tao": lngBytesOfECC = 0
                Case Else
                    Select Case SectorSize
                        Case Is = 2352: lngBytesOfECC = 304
                        Case Is = 2336: lngBytesOfECC = 288
                        Case Is = 2048: lngBytesOfECC = 0
                    End Select
            End Select
            
            'initialize variables
            ReDim IPS_AT_BYTE(1, 0)
            lngByteBuffer = 1
            lngBytesRemain = FileLen(sFile)
            i = 0
        
            'show progress bar
            frmProgress.Show
            
            'open cd image
            Open sFile For Binary As #1
                
                'loop the data
                Do
                    'check for cancel button
                    If StopProgress = True Then
                        Close #1
                        Unload frmProgress
                        Exit Sub
                    End If
                    
                    '64KB buffer plus an extra sector incase IP_IDENTIFIER is cut off by the 64KB buffer.
                    'the extra sector is "just" extra "in case." the data in the sector is reused in the
                    'next 64KB buffer.
                    
                    '** IT'S ACTUALLY MORE COMPLICATED THAN THAT **
                    
                    ReDim btBuffer(65536 + (2048 + lngBytesOfECC + Len(IP_IDENTIFIER)) - 2) As Byte
                    Get #1, lngByteBuffer, btBuffer()
                    strChunk = StrConv(btBuffer(), vbUnicode)
                    
                    'check for IP_IDENTIFIER
                    lngByteIP = InStr(1, Mid$(strChunk, 1, 65536 + Len(IP_IDENTIFIER) - 1), IP_IDENTIFIER)
                    If lngByteIP Then
                    
                        'check for IP0000.BIN
                        lngByteIP0000 = InStr(1, Mid$(strChunk, lngByteIP + 2048 + lngBytesOfECC, Len(IP_IDENTIFIER)), IP_IDENTIFIER)
                        If lngByteIP0000 Then
                            'ip0000.bin
                            ReDim Preserve IPS_AT_BYTE(1, i)
                            IPS_AT_BYTE(0, i) = "IP0000.BIN"
                            IPS_AT_BYTE(1, i) = (lngByteBuffer - 1) + lngByteIP 'current byte
                        Else
                            'ip.bin
                            ReDim Preserve IPS_AT_BYTE(1, i)
                            IPS_AT_BYTE(0, i) = "IP.BIN"
                            IPS_AT_BYTE(1, i) = (lngByteBuffer - 1) + lngByteIP 'current byte
                        End If
                        
                        'drop everything after cur byte + 32 KB
                        lngBytesRemain = lngBytesRemain - (lngByteIP + 32768 + (16 * lngBytesOfECC)) - 1
                        lngByteBuffer = lngByteBuffer + lngByteIP + 32768 + (16 * lngBytesOfECC) - 1
                        
                        i = i + 1
                    Else 'IP_IDENTIFIER not found
                    
                        'drop the entire buffer
                        lngBytesRemain = lngBytesRemain - 65536
                        lngByteBuffer = lngByteBuffer + 65536
                        
                    End If
                    
                    'update progress bar
                    PercentDone = (LOF(1) - lngBytesRemain) / LOF(1)
                    PercentDone = PercentDone * 4200
                    frmProgress.lblProgress.Width = PercentDone
                    
                    DoEvents
                Loop Until lngBytesRemain <= 0
            Close #1
            
            'close the progress bar
            Unload frmProgress
            
            'make sure the identifier was found
            If IPS_AT_BYTE(0, 0) = "" Then
                MsgBox "There is no IP.BIN or IP0000.BIN in this CD image.", vbExclamation, "Error"
                Exit Sub
            End If
            
            tempFile = sFile
            
            'show the list of found identifiers
            frmCDImage.Show vbModal
            If frmCDImage.Canceled = True Then Exit Sub
            
            'read the selected identifier meta info
            Open sFile For Binary As #1
                ReDim btMetaInfo(256 - 1) As Byte
                Get #1, bytePosition, btMetaInfo
                sMetaInfo = StrConv(btMetaInfo, vbUnicode)
            Close #1
            
            For i = LBound(IPS_AT_BYTE, 2) To UBound(IPS_AT_BYTE, 2)
                If IPS_AT_BYTE(1, i) = bytePosition Then
                    'enable menu items accordingly
                    Select Case IPS_AT_BYTE(0, i)
                        Case "IP.BIN"
                            frmMain.imgShowCDImage.Visible = True
                            frmMain.mnuOptionsExtractIP.Caption = "Extract IP.BIN"
                            frmMain.mnuOptionsExtractMRLogo.Enabled = True
                            frmMain.mnuOptionsViewMRLogo.Enabled = True
                            frmMain.mnuOptionsExtractSegaMRLogo.Enabled = True
                            frmMain.mnuOptionsExtractTMMRLogo.Enabled = True
                            frmMain.mnuOptionsExtractIP.Enabled = True
                            frmMain.cmdSave.Enabled = True
                            frmMain.mnuFileSave.Enabled = True
                            frmMain.mnuOptionsAddMRLogo.Enabled = True
                            frmMain.mnuOptionsRemoveMRLogo.Enabled = True
                            frmMain.mnuOptionsAddMRLogo.Enabled = True
                            frmMain.mnuOptionsRemoveMRLogo.Enabled = True
                            Exit For
                        Case "IP0000.BIN"
                            frmMain.imgShowCDImage.Visible = True
                            frmMain.mnuOptionsExtractIP.Caption = "Extract IP0000.BIN"
                            frmMain.mnuOptionsExtractMRLogo.Enabled = False
                            frmMain.mnuOptionsViewMRLogo.Enabled = False
                            frmMain.mnuOptionsExtractSegaMRLogo.Enabled = False
                            frmMain.mnuOptionsExtractTMMRLogo.Enabled = False
                            frmMain.mnuOptionsAddMRLogo.Enabled = False
                            frmMain.mnuOptionsRemoveMRLogo.Enabled = False
                            frmMain.mnuOptionsAddMRLogo.Enabled = False
                            frmMain.mnuOptionsRemoveMRLogo.Enabled = False
                            frmMain.mnuOptionsExtractIP.Enabled = True
                            frmMain.cmdSave.Enabled = True
                            frmMain.mnuFileSave.Enabled = True
                            Exit For
                    End Select
                End If
            Next
        
        '//
        '// CD-ROM
        '//
        Case SOURCE_CDROM
            sMetaInfo = meta
            sFile = strDrvLetter
            
        '//
        '// IP.BIN
        '//
        Case SOURCE_IP
            'open ip.bin
            Open sFile For Binary As #1
                ReDim btMeta(256 - 1) As Byte 'buffer
                Get #1, , btMeta() 'put meta info in the buffer
                sMetaInfo = StrConv(btMeta(), vbUnicode) 'convert to a readable format
                ReDim btTemp(Len(IP_IDENTIFIER) - 1) As Byte 'ip0000.bin buffer
                Get #1, 2049, btTemp() 'put ip0000.bin meta info in the buffer
            Close #1
            
            If StrConv(btTemp(), vbUnicode) = IP_IDENTIFIER Then
                'ip0000.bin buffer is a ip0000.bin
                frmMain.imgShowCDImage.Visible = False
                frmMain.mnuOptionsAddMRLogo.Enabled = False
                frmMain.mnuOptionsExtractMRLogo.Enabled = False
                frmMain.mnuOptionsRemoveMRLogo.Enabled = False
                frmMain.mnuOptionsViewMRLogo.Enabled = False
                frmMain.mnuOptionsExtractSegaMRLogo.Enabled = False
                frmMain.mnuOptionsExtractTMMRLogo.Enabled = False
                frmMain.mnuOptionsExtractIP.Caption = "Extract IP0000.BIN"
                frmMain.mnuOptionsExtractIP.Enabled = False
                frmMain.cmdSave.Enabled = True
                frmMain.mnuFileSave.Enabled = True
            Else
                'ip0000.bin buffer is a ip.bin
                frmMain.imgShowCDImage.Visible = False
                frmMain.mnuOptionsAddMRLogo.Enabled = True
                frmMain.mnuOptionsExtractMRLogo.Enabled = True
                frmMain.mnuOptionsRemoveMRLogo.Enabled = True
                frmMain.mnuOptionsViewMRLogo.Enabled = True
                frmMain.mnuOptionsExtractSegaMRLogo.Enabled = True
                frmMain.mnuOptionsExtractTMMRLogo.Enabled = True
                frmMain.mnuOptionsExtractIP.Caption = "Extract IP.BIN"
                frmMain.mnuOptionsExtractIP.Enabled = False
                frmMain.cmdSave.Enabled = True
                frmMain.mnuFileSave.Enabled = True
            End If
            
    End Select
    
    frmMain.txtFilename.Text = sFile
    
    Call DecodeMetaInfo(sMetaInfo)

    Exit Sub

ErrorHandler:
    MsgBox "ReadIP - modIP" & vbCrLf & vbCrLf & Err & " - " & Err.Description, vbCritical, "Error"

End Sub

'Extract IP.BIN\IP0000.BIN
Public Sub ExtractIP(ByVal sFile As String, src As enm_Source)
    
On Error GoTo ErrorHandler

    Dim strIPData       As String
    Dim strSaveName     As String
    Dim strCdlgFilter   As String
    Dim i               As Integer

    Select Case src
    
        '//
        '// CD IMAGE
        '//
        Case SOURCE_CDIMAGE
            Open sFile For Binary As #1
                ReDim btIP(2048 - 1) As Byte 'buffer of sector
                Get #1, bytePosition, btIP() 'first sector in buffer
                strIPData = StrConv(btIP(), vbUnicode)
                
                For i = 1 To 15
                    Seek #1, Loc(1) + lngBytesOfECC + 1
                    Get #1, , btIP()
                    strIPData = strIPData & StrConv(btIP(), vbUnicode)
                Next
            Close #1
        
        '//
        '// CD-ROM
        '//
        Case SOURCE_CDROM
            ReDim btIP(32768 - 1) As Byte
            Call ExtractSector(strDrvLetter, CDROM_LBA, 16, btIP)
            strIPData = StrConv(btIP(), vbUnicode)
            
    End Select
            
    Select Case frmMain.mnuOptionsExtractIP.Caption
        Case "Extract IP.BIN" 'current is IP.BIN
            strSaveName = ShowSave("IP.BIN (*.bin)|*.bin| All files (*.*)|*.*", "IP.BIN", "BIN", OVERWRITEPROMPT, frmMain)
            If strSaveName = "" Then Exit Sub
    
            Open strSaveName For Output As #1
                Print #1, strIPData;
            Close #1
            
            MsgBox "The IP.BIN was successfully extracted!", vbInformation, "Information"
        Case "Extract IP0000.BIN" 'current is IP0000.BIN
            strSaveName = ShowSave("IP0000.BIN (*.bin)|*.bin|All files (*.*)|*.*", "IP0000.BIN", "BIN", OVERWRITEPROMPT, frmMain)
            If strSaveName = "" Then Exit Sub
            IPFORMAT = FORMAT_IP0000
            
            Open strSaveName For Output As #1
                Print #1, strIPData;
            Close #1
            
            MsgBox "The IP0000.BIN was successfully extracted!", vbInformation, "Information"
    End Select

    Exit Sub

ErrorHandler:
    MsgBox "ExtractIP - modIP" & vbCrLf & vbCrLf & Err & " - " & Err.Description, vbCritical, "Error"
    
End Sub

'Save (update) IP.BIN\CD images
Public Sub SaveIP(ByVal sFile As String)
    
On Error GoTo ErrorHandler

    Dim sMetaInfo As String
    Dim strExtension As String
    Dim i As Integer, j As Integer
    
    If FileExist(frmMain.txtFilename.Text) = False Then
    
        If FileExist(AppPath & "IP.TMPL") = False Then
            Call MsgBox("Sorry, IP.TMPL could not be found.", vbExclamation, "Error")
            Exit Sub
        End If
        
        frmMain.txtFilename.Text = sFile
        
        'save new IP.BIN
        Open AppPath & "IP.TMPL" For Binary As #1
            ReDim btTemplate((32768 - 256) - 1) As Byte 'buffer for IP.BIN template
            Get #1, 257, btTemplate 'put template in variable buffer
            Open sFile For Binary As #2
                Put #2, , EncodeMetaInfo(False) 'encode meta info without calc. CRC.
                Put #2, , btTemplate 'save template in sFile
            Close #2
        Close #1
        
        Call MsgBox("The IP.BIN was successfully created!", vbInformation, "Information")
        
    Else 'updating
    
        If FileLen(sFile) = 32768 Then
        
            'IP.BIN
            Open sFile For Binary As #1
                sMetaInfo = EncodeMetaInfo(False) 'encode meta info without calc. CRC.
                Put #1, , sMetaInfo
            Close #1
            
            Call MsgBox("The IP.BIN was successfully updated!", vbInformation, "Information")
            
        ElseIf FileLen(sFile) > 32768 Then
                                    
            'cd image
            Select Case MsgBoxA("Do you want to update the current " & IIf(frmMain.mnuOptionsExtractIP.Caption = "Extract IP.BIN", "IP.BIN", "IP0000.BIN") & " or the entire CD image?", "Question", "", MB_ICONQUESTION + MB_YESNOCANCEL, , "Cancel", "Current", "All")
                
                '//
                '//update current
                '//
                Case vbYes
                    For i = LBound(IPS_AT_BYTE, 2) To UBound(IPS_AT_BYTE, 2)
                        If bytePosition = IPS_AT_BYTE(1, i) Then
                            
                            Select Case IPS_AT_BYTE(0, i)
                                Case "IP.BIN" 'current byte has IP.BIN
                                    Open sFile For Binary As #1
                                        Put #1, IPS_AT_BYTE(1, i), EncodeMetaInfo(False) 'save meta info w\o CRC calc.
                                    Close #1
                                    Exit For
                                Case "IP0000.BIN" 'current byte has IP0000.BIN
                                    Open sFile For Binary As #1
                                        Put #1, IPS_AT_BYTE(1, i), EncodeMetaInfo(True) 'save meta info with CRC calc.
                                        'repeat meta info 15 more times
                                        For j = 1 To 15
                                            Seek #1, Loc(1) + (2048 - 256) + lngBytesOfECC + 1 'skip ECC
                                            Put #1, , EncodeMetaInfo(True) 'save meta info with CRC calc.
                                        Next
                                    Close #1
                                    Exit For
                            End Select
                            
                        End If
                    Next
                
                '//
                '//update all
                '//
                Case vbNo
                    For i = LBound(IPS_AT_BYTE, 2) To UBound(IPS_AT_BYTE, 2)
                    
                        Select Case IPS_AT_BYTE(0, i)
                            Case "IP.BIN" 'byte i has IP.BIN
                                Open sFile For Binary As #1
                                    Put #1, IPS_AT_BYTE(1, i), EncodeMetaInfo(False) 'save meta info w\o CRC calc.
                                Close #1
                            Case "IP0000.BIN" 'byte i has IP0000.BIN
                                Open sFile For Binary As #1
                                    Put #1, IPS_AT_BYTE(1, i), EncodeMetaInfo(True) 'save meta info with CRC calc.
                                    'repeat meta info 15 more times
                                    For j = 1 To 15
                                        Seek #1, Loc(1) + (2048 - 256) + lngBytesOfECC + 1 'skip ECC
                                        Put #1, , EncodeMetaInfo(True) 'save meta info with CRC calc.
                                    Next
                                Close #1
                        End Select
                        
                    Next
                
                '//
                '//cancel
                '//
                Case vbCancel
                    Exit Sub
                    
            End Select
            
            Call MsgBox("The CD image was successfully updated!", vbInformation, "Information")
            
        End If
        
    End If

    Exit Sub

ErrorHandler:
    MsgBox "SaveIP - modIP" & vbCrLf & vbCrLf & Err & " - " & Err.Description, vbCritical, "Error"

End Sub

'Save (update) IP0000.BIN
Public Sub SaveIP0000(ByVal sFile As String)
    
On Error GoTo ErrorHandler

    Dim sMetaInfo   As String
    Dim strIPData     As String
    Dim i           As Integer

    If FileExist(frmMain.txtFilename.Text) = False Then
    
        'new IP0000.BIN
        frmMain.txtFilename.Text = sFile
        
        Open sFile For Binary As #1
            sMetaInfo = EncodeMetaInfo(True) 'save meta info w\ CRC calc.
            
            'pad out to sector size
            Do Until Len(sMetaInfo) = 2048
                sMetaInfo = sMetaInfo & Chr$(0)
            Loop
            
            'repeat 16 times
            For i = 1 To 16
                strIPData = strIPData & sMetaInfo
            Next
            
            Put #1, , strIPData
        Close #1
        
        Call MsgBox("The IP0000.BIN was successfully created!", vbInformation, "Information")
        
    Else 'updating
    
        Open sFile For Binary As #1
            sMetaInfo = EncodeMetaInfo(True) 'save meta info w\ CRC calc.
            
            'repeat 16 times
            For i = 1 To 16
                Put #1, , sMetaInfo
                Seek #1, Loc(1) + 1792 + 1 'seek to next sector
            Next i
        Close #1
        
        Call MsgBox("The IP0000.BIN was successfully updated!", vbInformation, "Information")
        
    End If

    Exit Sub

ErrorHandler:
    MsgBox "SaveIP0000 - modIP" & vbCrLf & vbCrLf & Err & " - " & Err.Description, vbCritical, "Error"

End Sub

Public Sub DecodeMetaInfo(meta As String)

    Dim i As Integer
    Dim AreaSymbols As String, AreaSymbol As String
    Dim Peripherals As String, Peripheral As String

    frmMain.txtHardwareID.Text = Trim$(Mid$(meta, 1, 16))
    frmMain.txtMakerID.Text = Trim$(Mid$(meta, 17, 16))
    frmMain.txtDeviceInformation.Text = Trim$(Mid$(meta, 33, 4))
    frmMain.cboDeviceInformation.Text = Trim$(Mid$(meta, 38, 11))
    
    AreaSymbols = Mid$(meta, 49, 8)
    For i = 1 To 3
        AreaSymbol = Mid$(AreaSymbols, i, 1)
        Select Case i
            Case 1: If AreaSymbol = "J" Then frmMain.cbAreaSymbolJ.Value = 1 Else frmMain.cbAreaSymbolJ.Value = 0
            Case 2: If AreaSymbol = "U" Then frmMain.cbAreaSymbolU.Value = 1 Else frmMain.cbAreaSymbolU.Value = 0
            Case 3: If AreaSymbol = "E" Then frmMain.cbAreaSymbolE.Value = 1 Else frmMain.cbAreaSymbolE.Value = 0
        End Select
    Next
    
    Peripherals = Trim$(Mid$(meta, 57, 8))
    For i = 1 To 7
        Peripheral = Mid$(Peripherals, i, 1)
        Select Case i
            Case 1
                Select Case Peripheral
                    Case "0"
                        frmMain.cbMouse.Value = 0
                        frmMain.cbKeyboard.Value = 0
                        frmMain.cbGun.Value = 0
                        frmMain.cbExpandedVertical.Value = 0
                    Case "1"
                        frmMain.cbMouse.Value = 0
                        frmMain.cbKeyboard.Value = 0
                        frmMain.cbGun.Value = 0
                        frmMain.cbExpandedVertical.Value = 1
                    Case "2"
                        frmMain.cbMouse.Value = 0
                        frmMain.cbKeyboard.Value = 1
                        frmMain.cbGun.Value = 0
                        frmMain.cbExpandedVertical.Value = 0
                    Case "3"
                        frmMain.cbMouse.Value = 0
                        frmMain.cbKeyboard.Value = 1
                        frmMain.cbGun.Value = 0
                        frmMain.cbExpandedVertical.Value = 1
                    Case "4"
                        frmMain.cbMouse.Value = 0
                        frmMain.cbKeyboard.Value = 0
                        frmMain.cbGun.Value = 1
                        frmMain.cbExpandedVertical.Value = 0
                    Case "5"
                        frmMain.cbMouse.Value = 0
                        frmMain.cbKeyboard.Value = 0
                        frmMain.cbGun.Value = 1
                        frmMain.cbExpandedVertical.Value = 1
                    Case "6"
                        frmMain.cbMouse.Value = 0
                        frmMain.cbKeyboard.Value = 1
                        frmMain.cbGun.Value = 1
                        frmMain.cbExpandedVertical.Value = 0
                    Case "7"
                        frmMain.cbMouse.Value = 0
                        frmMain.cbKeyboard.Value = 1
                        frmMain.cbGun.Value = 1
                        frmMain.cbExpandedVertical.Value = 1
                    Case "8"
                        frmMain.cbMouse.Value = 1
                        frmMain.cbKeyboard.Value = 0
                        frmMain.cbGun.Value = 0
                        frmMain.cbExpandedVertical.Value = 0
                    Case "9"
                        frmMain.cbMouse.Value = 1
                        frmMain.cbKeyboard.Value = 0
                        frmMain.cbGun.Value = 0
                        frmMain.cbExpandedVertical.Value = 1
                    Case "A"
                        frmMain.cbMouse.Value = 1
                        frmMain.cbKeyboard.Value = 1
                        frmMain.cbGun.Value = 0
                        frmMain.cbExpandedVertical.Value = 0
                    Case "B"
                        frmMain.cbMouse.Value = 1
                        frmMain.cbKeyboard.Value = 1
                        frmMain.cbGun.Value = 0
                        frmMain.cbExpandedVertical.Value = 1
                    Case "C"
                        frmMain.cbMouse.Value = 1
                        frmMain.cbKeyboard.Value = 0
                        frmMain.cbGun.Value = 1
                        frmMain.cbExpandedVertical.Value = 0
                    Case "D"
                        frmMain.cbMouse.Value = 1
                        frmMain.cbKeyboard.Value = 0
                        frmMain.cbGun.Value = 1
                        frmMain.cbExpandedVertical.Value = 1
                    Case "E"
                        frmMain.cbMouse.Value = 1
                        frmMain.cbKeyboard.Value = 1
                        frmMain.cbGun.Value = 1
                        frmMain.cbExpandedVertical.Value = 0
                    Case "F"
                        frmMain.cbMouse.Value = 1
                        frmMain.cbKeyboard.Value = 1
                        frmMain.cbGun.Value = 1
                        frmMain.cbExpandedVertical.Value = 1
                    Case Else
                        MsgBox "Incorrect Hex value: &H" & Hex$(Asc(Peripheral)), vbCritical, "Error"
                End Select
            Case 2
                Select Case Peripheral
                    Case "0"
                        frmMain.cbExpandedHorizontal.Value = 0
                        frmMain.cbAnalogVertical.Value = 0
                        frmMain.cbAnalogHorizontal.Value = 0
                        frmMain.cbAnalogLTrigger.Value = 0
                    Case "1"
                        frmMain.cbExpandedHorizontal.Value = 0
                        frmMain.cbAnalogVertical.Value = 0
                        frmMain.cbAnalogHorizontal.Value = 0
                        frmMain.cbAnalogLTrigger.Value = 1
                    Case "2"
                        frmMain.cbExpandedHorizontal.Value = 0
                        frmMain.cbAnalogVertical.Value = 1
                        frmMain.cbAnalogHorizontal.Value = 0
                        frmMain.cbAnalogLTrigger.Value = 0
                    Case "3"
                        frmMain.cbExpandedHorizontal.Value = 0
                        frmMain.cbAnalogVertical.Value = 1
                        frmMain.cbAnalogHorizontal.Value = 0
                        frmMain.cbAnalogLTrigger.Value = 1
                    Case "4"
                        frmMain.cbExpandedHorizontal.Value = 0
                        frmMain.cbAnalogVertical.Value = 0
                        frmMain.cbAnalogHorizontal.Value = 1
                        frmMain.cbAnalogLTrigger.Value = 0
                    Case "5"
                        frmMain.cbExpandedHorizontal.Value = 0
                        frmMain.cbAnalogVertical.Value = 0
                        frmMain.cbAnalogHorizontal.Value = 1
                        frmMain.cbAnalogLTrigger.Value = 1
                    Case "6"
                        frmMain.cbExpandedHorizontal.Value = 0
                        frmMain.cbAnalogVertical.Value = 1
                        frmMain.cbAnalogHorizontal.Value = 1
                        frmMain.cbAnalogLTrigger.Value = 0
                    Case "7"
                        frmMain.cbExpandedHorizontal.Value = 0
                        frmMain.cbAnalogVertical.Value = 1
                        frmMain.cbAnalogHorizontal.Value = 1
                        frmMain.cbAnalogLTrigger.Value = 1
                    Case "8"
                        frmMain.cbExpandedHorizontal.Value = 1
                        frmMain.cbAnalogVertical.Value = 0
                        frmMain.cbAnalogHorizontal.Value = 0
                        frmMain.cbAnalogLTrigger.Value = 0
                    Case "9"
                        frmMain.cbExpandedHorizontal.Value = 1
                        frmMain.cbAnalogVertical.Value = 0
                        frmMain.cbAnalogHorizontal.Value = 0
                        frmMain.cbAnalogLTrigger.Value = 1
                    Case "A"
                        frmMain.cbExpandedHorizontal.Value = 1
                        frmMain.cbAnalogVertical.Value = 1
                        frmMain.cbAnalogHorizontal.Value = 0
                        frmMain.cbAnalogLTrigger.Value = 0
                    Case "B"
                        frmMain.cbExpandedHorizontal.Value = 1
                        frmMain.cbAnalogVertical.Value = 1
                        frmMain.cbAnalogHorizontal.Value = 0
                        frmMain.cbAnalogLTrigger.Value = 1
                    Case "C"
                        frmMain.cbExpandedHorizontal.Value = 1
                        frmMain.cbAnalogVertical.Value = 0
                        frmMain.cbAnalogHorizontal.Value = 1
                        frmMain.cbAnalogLTrigger.Value = 0
                    Case "D"
                        frmMain.cbExpandedHorizontal.Value = 1
                        frmMain.cbAnalogVertical.Value = 0
                        frmMain.cbAnalogHorizontal.Value = 1
                        frmMain.cbAnalogLTrigger.Value = 1
                    Case "E"
                        frmMain.cbExpandedHorizontal.Value = 1
                        frmMain.cbAnalogVertical.Value = 1
                        frmMain.cbAnalogHorizontal.Value = 1
                        frmMain.cbAnalogLTrigger.Value = 0
                    Case "F"
                        frmMain.cbExpandedHorizontal.Value = 1
                        frmMain.cbAnalogVertical.Value = 1
                        frmMain.cbAnalogHorizontal.Value = 1
                        frmMain.cbAnalogLTrigger.Value = 1
                    Case Else
                        MsgBox "Incorrect Hex value: &H" & Hex$(Asc(Peripheral)), vbCritical, "Error"
                End Select
            Case 3
                Select Case Peripheral
                    Case "0"
                        frmMain.cbAnalogRTrigger.Value = 0
                        frmMain.cbZbutton.Value = 0
                        frmMain.cbYbutton.Value = 0
                        frmMain.cbExpandedDirectionButtons.Value = 0
                    Case "1"
                        frmMain.cbAnalogRTrigger.Value = 0
                        frmMain.cbYbutton.Value = 1
                        frmMain.cbZbutton.Value = 0
                        frmMain.cbExpandedDirectionButtons.Value = 0
                    Case "2"
                        frmMain.cbExpandedDirectionButtons.Value = 1
                        frmMain.cbAnalogRTrigger.Value = 0
                        frmMain.cbZbutton.Value = 0
                        frmMain.cbYbutton.Value = 0
                    Case "3"
                        frmMain.cbExpandedDirectionButtons.Value = 1
                        frmMain.cbYbutton.Value = 1
                        frmMain.cbAnalogRTrigger.Value = 0
                        frmMain.cbZbutton.Value = 0
                    Case "4"
                        frmMain.cbZbutton.Value = 1
                        frmMain.cbAnalogRTrigger.Value = 0
                        frmMain.cbExpandedDirectionButtons.Value = 0
                        frmMain.cbYbutton.Value = 0
                    Case "5"
                        frmMain.cbZbutton.Value = 1
                        frmMain.cbYbutton.Value = 1
                        frmMain.cbAnalogRTrigger.Value = 0
                        frmMain.cbExpandedDirectionButtons.Value = 0
                    Case "6"
                        frmMain.cbZbutton.Value = 1
                        frmMain.cbExpandedDirectionButtons.Value = 1
                        frmMain.cbAnalogRTrigger.Value = 0
                        frmMain.cbYbutton.Value = 0
                    Case "7"
                        frmMain.cbZbutton.Value = 1
                        frmMain.cbExpandedDirectionButtons.Value = 1
                        frmMain.cbYbutton.Value = 1
                        frmMain.cbAnalogRTrigger.Value = 0
                    Case "8"
                        frmMain.cbAnalogRTrigger.Value = 1
                        frmMain.cbZbutton.Value = 0
                        frmMain.cbExpandedDirectionButtons.Value = 0
                        frmMain.cbYbutton.Value = 0
                    Case "9"
                        frmMain.cbAnalogRTrigger.Value = 1
                        frmMain.cbYbutton.Value = 1
                        frmMain.cbZbutton.Value = 0
                        frmMain.cbExpandedDirectionButtons.Value = 0
                    Case "A"
                        frmMain.cbAnalogRTrigger.Value = 1
                        frmMain.cbExpandedDirectionButtons.Value = 1
                        frmMain.cbZbutton.Value = 0
                        frmMain.cbYbutton.Value = 0
                    Case "B"
                        frmMain.cbAnalogRTrigger.Value = 1
                        frmMain.cbExpandedDirectionButtons.Value = 1
                        frmMain.cbYbutton.Value = 1
                        frmMain.cbZbutton.Value = 0
                    Case "C"
                        frmMain.cbAnalogRTrigger.Value = 1
                        frmMain.cbZbutton.Value = 1
                        frmMain.cbExpandedDirectionButtons.Value = 0
                        frmMain.cbYbutton.Value = 0
                    Case "D"
                        frmMain.cbAnalogRTrigger.Value = 1
                        frmMain.cbZbutton.Value = 1
                        frmMain.cbYbutton.Value = 1
                        frmMain.cbExpandedDirectionButtons.Value = 0
                    Case "E"
                        frmMain.cbAnalogRTrigger.Value = 1
                        frmMain.cbZbutton.Value = 1
                        frmMain.cbExpandedDirectionButtons.Value = 1
                        frmMain.cbYbutton.Value = 0
                    Case "F"
                        frmMain.cbAnalogRTrigger.Value = 1
                        frmMain.cbZbutton.Value = 1
                        frmMain.cbExpandedDirectionButtons.Value = 1
                        frmMain.cbYbutton.Value = 1
                    Case Else
                        MsgBox "Incorrect Hex value: &H" & Hex$(Asc(Peripheral)), vbCritical, "Error"
                End Select
            Case 4
                Select Case Peripheral
                    Case "0"
                        frmMain.cbXbutton.Value = 0
                        frmMain.cbCbutton.Value = 0
                        frmMain.cbDbutton.Value = 0
                        frmMain.cbStartABDirections.Value = 0
                    Case "1"
                        frmMain.cbStartABDirections.Value = 1
                        frmMain.cbXbutton.Value = 0
                        frmMain.cbCbutton.Value = 0
                        frmMain.cbDbutton.Value = 0
                    Case "2"
                        frmMain.cbDbutton.Value = 1
                        frmMain.cbXbutton.Value = 0
                        frmMain.cbCbutton.Value = 0
                        frmMain.cbStartABDirections.Value = 0
                    Case "3"
                        frmMain.cbDbutton.Value = 1
                        frmMain.cbStartABDirections.Value = 1
                        frmMain.cbXbutton.Value = 0
                        frmMain.cbCbutton.Value = 0
                    Case "4"
                        frmMain.cbCbutton.Value = 1
                        frmMain.cbXbutton.Value = 0
                        frmMain.cbDbutton.Value = 0
                        frmMain.cbStartABDirections.Value = 0
                    Case "5"
                        frmMain.cbCbutton.Value = 1
                        frmMain.cbStartABDirections.Value = 1
                        frmMain.cbXbutton.Value = 0
                        frmMain.cbDbutton.Value = 0
                    Case "6"
                        frmMain.cbCbutton.Value = 1
                        frmMain.cbDbutton.Value = 1
                        frmMain.cbXbutton.Value = 0
                        frmMain.cbStartABDirections.Value = 0
                    Case "7"
                        frmMain.cbCbutton.Value = 1
                        frmMain.cbDbutton.Value = 1
                        frmMain.cbStartABDirections.Value = 1
                        frmMain.cbXbutton.Value = 0
                    Case "8"
                        frmMain.cbXbutton.Value = 1
                        frmMain.cbCbutton.Value = 0
                        frmMain.cbDbutton.Value = 0
                        frmMain.cbStartABDirections.Value = 0
                    Case "9"
                        frmMain.cbXbutton.Value = 1
                        frmMain.cbStartABDirections.Value = 1
                        frmMain.cbCbutton.Value = 0
                        frmMain.cbDbutton.Value = 0
                    Case "A"
                        frmMain.cbXbutton.Value = 1
                        frmMain.cbDbutton.Value = 1
                        frmMain.cbCbutton.Value = 0
                        frmMain.cbStartABDirections.Value = 0
                    Case "B"
                        frmMain.cbXbutton.Value = 1
                        frmMain.cbDbutton.Value = 1
                        frmMain.cbStartABDirections.Value = 1
                        frmMain.cbCbutton.Value = 0
                    Case "C"
                        frmMain.cbXbutton.Value = 1
                        frmMain.cbCbutton.Value = 1
                        frmMain.cbDbutton.Value = 0
                        frmMain.cbStartABDirections.Value = 0
                    Case "D"
                        frmMain.cbXbutton.Value = 1
                        frmMain.cbCbutton.Value = 1
                        frmMain.cbStartABDirections.Value = 1
                        frmMain.cbDbutton.Value = 0
                    Case "E"
                        frmMain.cbXbutton.Value = 1
                        frmMain.cbCbutton.Value = 1
                        frmMain.cbDbutton.Value = 1
                        frmMain.cbStartABDirections.Value = 0
                    Case "F"
                        frmMain.cbXbutton.Value = 1
                        frmMain.cbCbutton.Value = 1
                        frmMain.cbDbutton.Value = 1
                        frmMain.cbStartABDirections.Value = 1
                    Case Else
                        MsgBox "Incorrect Hex value: &H" & Hex$(Asc(Peripheral)), vbCritical, "Error"
                End Select
            Case 5
                Select Case Peripheral
                    Case "0"
                        frmMain.cbMemoryCard.Value = 0
                        frmMain.cbPuruPuruPack.Value = 0
                        frmMain.cbMicrophone.Value = 0
                        frmMain.cbOtherExpansions.Value = 0
                    Case "1"
                        frmMain.cbOtherExpansions.Value = 1
                        frmMain.cbMemoryCard.Value = 0
                        frmMain.cbPuruPuruPack.Value = 0
                        frmMain.cbMicrophone.Value = 0
                    Case "2"
                        frmMain.cbMicrophone.Value = 1
                        frmMain.cbMemoryCard.Value = 0
                        frmMain.cbPuruPuruPack.Value = 0
                        frmMain.cbOtherExpansions.Value = 0
                    Case "3"
                        frmMain.cbMicrophone.Value = 1
                        frmMain.cbOtherExpansions.Value = 1
                        frmMain.cbMemoryCard.Value = 0
                        frmMain.cbPuruPuruPack.Value = 0
                    Case "4"
                        frmMain.cbPuruPuruPack.Value = 1
                        frmMain.cbMemoryCard.Value = 0
                        frmMain.cbMicrophone.Value = 0
                        frmMain.cbOtherExpansions.Value = 0
                    Case "5"
                        frmMain.cbPuruPuruPack.Value = 1
                        frmMain.cbOtherExpansions.Value = 1
                        frmMain.cbMemoryCard.Value = 0
                        frmMain.cbMicrophone.Value = 0
                    Case "6"
                        frmMain.cbPuruPuruPack.Value = 1
                        frmMain.cbMicrophone.Value = 1
                        frmMain.cbMemoryCard.Value = 0
                        frmMain.cbOtherExpansions.Value = 0
                    Case "7"
                        frmMain.cbPuruPuruPack.Value = 1
                        frmMain.cbMicrophone.Value = 1
                        frmMain.cbOtherExpansions.Value = 1
                        frmMain.cbMemoryCard.Value = 0
                    Case "8"
                        frmMain.cbMemoryCard.Value = 1
                        frmMain.cbPuruPuruPack.Value = 0
                        frmMain.cbMicrophone.Value = 0
                        frmMain.cbOtherExpansions.Value = 0
                    Case "9"
                        frmMain.cbMemoryCard.Value = 1
                        frmMain.cbOtherExpansions.Value = 1
                        frmMain.cbPuruPuruPack.Value = 0
                        frmMain.cbMicrophone.Value = 0
                    Case "A"
                        frmMain.cbMemoryCard.Value = 1
                        frmMain.cbMicrophone.Value = 1
                        frmMain.cbPuruPuruPack.Value = 0
                        frmMain.cbOtherExpansions.Value = 0
                    Case "B"
                        frmMain.cbMemoryCard.Value = 1
                        frmMain.cbMicrophone.Value = 1
                        frmMain.cbOtherExpansions.Value = 1
                        frmMain.cbPuruPuruPack.Value = 0
                    Case "C"
                        frmMain.cbMemoryCard.Value = 1
                        frmMain.cbPuruPuruPack.Value = 1
                        frmMain.cbMicrophone.Value = 0
                        frmMain.cbOtherExpansions.Value = 0
                    Case "D"
                        frmMain.cbMemoryCard.Value = 1
                        frmMain.cbPuruPuruPack.Value = 1
                        frmMain.cbOtherExpansions.Value = 1
                        frmMain.cbMicrophone.Value = 0
                    Case "E"
                        frmMain.cbMemoryCard.Value = 1
                        frmMain.cbPuruPuruPack.Value = 1
                        frmMain.cbMicrophone.Value = 1
                        frmMain.cbOtherExpansions.Value = 0
                    Case "F"
                        frmMain.cbMemoryCard.Value = 1
                        frmMain.cbPuruPuruPack.Value = 1
                        frmMain.cbMicrophone.Value = 1
                        frmMain.cbOtherExpansions.Value = 1
                    Case Else
                        MsgBox "Incorrect Hex value: &H" & Hex$(Asc(Peripheral)), vbCritical, "Error"
                End Select
            Case 6
                Select Case Peripheral
                    Case "0"
                        frmMain.cbVGABoxSupport.Value = 0
                    Case "1"
                        frmMain.cbVGABoxSupport.Value = 1
                    Case Else
                        MsgBox "Incorrect Hex value: &H" & Hex$(Asc(Peripheral)), vbCritical, "Error"
                End Select
            Case 7
                Select Case Peripheral
                    Case "0"
                        frmMain.cbUsesWindowsCE.Value = 0
                    Case "1"
                        frmMain.cbUsesWindowsCE.Value = 1
                    Case Else
                        MsgBox "Incorrect Hex value: &H" & Hex$(Asc(Peripheral)), vbCritical, "Error"
                End Select
        End Select
    Next
    
    frmMain.txtProductID.Text = Trim$(Mid$(meta, 65, 10))
    frmMain.txtProductVersion.Text = Trim$(Mid$(meta, 76, 5))
    frmMain.txtReleaseYear.Text = Trim$(Mid$(meta, 81, 4))
    frmMain.txtReleaseMonth.Text = Trim$(Mid$(meta, 85, 2))
    frmMain.txtReleaseDay.Text = Trim$(Mid$(meta, 87, 2))
    frmMain.cboBootFilename.Text = Trim$(Mid$(meta, 97, 16))
    frmMain.txtNameOfCompany.Text = Trim$(Mid$(meta, 113, 16))
    frmMain.txtNameOfSoftware.Text = Trim$(Mid$(meta, 129, 128))

End Sub

Public Function EncodeMetaInfo(blnCRC As Boolean) As String
    
On Error GoTo ErrorHandler

    Dim strHardwareID       As String * 16  'SEGA SEGAKATANA
    Dim strMakerID          As String * 16  'SEGA ENTERPRISES
    Dim strDeviceInfo       As String * 16  'CRC, Media format
    Dim strAreaSymbols      As String       'Regional territories
    Dim strPeripherals      As String * 8   'Supported devices, VGA, WinCE
    Dim strProductID        As String * 10
    Dim strProductVer       As String * 6
    Dim strReleaseDate      As String * 16
    Dim strBootFilename     As String * 16
    Dim strNameOfCompany    As String * 16
    Dim strNameOfSoftware   As String * 128
    
    Dim Periph1 As String
    Dim Periph2 As String
    Dim Periph3 As String
    Dim Periph4 As String
    Dim Periph5 As String
    Dim Periph6 As String
    Dim Periph7 As String

    strHardwareID = frmMain.txtHardwareID.Text
    strMakerID = frmMain.txtMakerID.Text
    
    If blnCRC = True Then
        If frmMain.mnuOptionsExtractIP.Caption = "Extract IP0000.BIN" Then
            frmMain.txtDeviceInformation.Text = calcCRC
            strDeviceInfo = frmMain.txtDeviceInformation.Text & " " & frmMain.cboDeviceInformation.Text
        Else
            strDeviceInfo = calcCRC & " " & frmMain.cboDeviceInformation.Text
        End If
    Else
        strDeviceInfo = frmMain.txtDeviceInformation.Text & " " & frmMain.cboDeviceInformation.Text
    End If
    
    If frmMain.cbAreaSymbolJ.Value = 1 Then strAreaSymbols = "J" Else strAreaSymbols = " "
    If frmMain.cbAreaSymbolU.Value = 1 Then strAreaSymbols = strAreaSymbols & "U" Else strAreaSymbols = strAreaSymbols & " "
    If frmMain.cbAreaSymbolE.Value = 1 Then strAreaSymbols = strAreaSymbols & "E" Else strAreaSymbols = strAreaSymbols & " "
    Do While Len(strAreaSymbols) < 8: strAreaSymbols = strAreaSymbols & " ": Loop
    
    Periph1 = "0"
    If frmMain.cbExpandedVertical.Value = 1 Then Periph1 = "1"
    If frmMain.cbKeyboard.Value = 1 Then Periph1 = "2"
    If frmMain.cbKeyboard.Value = 1 And frmMain.cbExpandedVertical.Value = 1 Then Periph1 = "3"
    If frmMain.cbGun.Value = 1 Then Periph1 = "4"
    If frmMain.cbGun.Value = 1 And frmMain.cbExpandedVertical.Value = 1 Then Periph1 = "5"
    If frmMain.cbGun.Value = 1 And frmMain.cbKeyboard.Value = 1 Then Periph1 = "6"
    If frmMain.cbGun.Value = 1 And frmMain.cbKeyboard.Value = 1 And frmMain.cbExpandedVertical.Value = 1 Then Periph1 = "7"
    If frmMain.cbMouse.Value = 1 Then Periph1 = "8"
    If frmMain.cbMouse.Value = 1 And frmMain.cbExpandedVertical.Value = 1 Then Periph1 = "9"
    If frmMain.cbMouse.Value = 1 And frmMain.cbKeyboard.Value = 1 Then Periph1 = "A"
    If frmMain.cbMouse.Value = 1 And frmMain.cbKeyboard.Value = 1 And frmMain.cbExpandedVertical.Value = 1 Then Periph1 = "B"
    If frmMain.cbMouse.Value = 1 And frmMain.cbGun.Value = 1 Then Periph1 = "C"
    If frmMain.cbMouse.Value = 1 And frmMain.cbGun.Value = 1 And frmMain.cbExpandedVertical.Value = 1 Then Periph1 = "D"
    If frmMain.cbMouse.Value = 1 And frmMain.cbGun.Value = 1 And frmMain.cbKeyboard.Value = 1 Then Periph1 = "E"
    If frmMain.cbMouse.Value = 1 And frmMain.cbGun.Value = 1 And frmMain.cbKeyboard.Value = 1 And frmMain.cbExpandedVertical.Value = 1 Then Periph1 = "F"
    
    Periph2 = "0"
    If frmMain.cbAnalogLTrigger.Value = 1 Then Periph2 = "1"
    If frmMain.cbAnalogVertical.Value = 1 Then Periph2 = "2"
    If frmMain.cbAnalogVertical.Value = 1 And frmMain.cbAnalogLTrigger.Value = 1 Then Periph2 = "3"
    If frmMain.cbAnalogHorizontal.Value = 1 Then Periph2 = "4"
    If frmMain.cbAnalogHorizontal.Value = 1 And frmMain.cbAnalogLTrigger.Value = 1 Then Periph2 = "5"
    If frmMain.cbAnalogHorizontal.Value = 1 And frmMain.cbAnalogVertical.Value = 1 Then Periph2 = "6"
    If frmMain.cbAnalogHorizontal.Value = 1 And frmMain.cbAnalogVertical.Value = 1 And frmMain.cbAnalogLTrigger.Value = 1 Then Periph2 = "7"
    If frmMain.cbExpandedHorizontal.Value = 1 Then Periph2 = "8"
    If frmMain.cbExpandedHorizontal.Value = 1 And frmMain.cbAnalogLTrigger.Value = 1 Then Periph2 = "9"
    If frmMain.cbExpandedHorizontal.Value = 1 And frmMain.cbAnalogVertical.Value = 1 Then Periph2 = "A"
    If frmMain.cbExpandedHorizontal.Value = 1 And frmMain.cbAnalogVertical.Value = 1 And frmMain.cbAnalogLTrigger.Value = 1 Then Periph2 = "B"
    If frmMain.cbExpandedHorizontal.Value = 1 And frmMain.cbAnalogHorizontal.Value = 1 Then Periph2 = "C"
    If frmMain.cbExpandedHorizontal.Value = 1 And frmMain.cbAnalogHorizontal.Value = 1 And frmMain.cbAnalogLTrigger.Value = 1 Then Periph2 = "D"
    If frmMain.cbExpandedHorizontal.Value = 1 And frmMain.cbAnalogHorizontal.Value = 1 And frmMain.cbAnalogVertical.Value = 1 Then Periph2 = "E"
    If frmMain.cbExpandedHorizontal.Value = 1 And frmMain.cbAnalogHorizontal.Value = 1 And frmMain.cbAnalogVertical.Value = 1 And frmMain.cbAnalogLTrigger.Value = 1 Then Periph2 = "F"
    
    Periph3 = "0"
    If frmMain.cbYbutton.Value = 1 Then Periph3 = "1"
    If frmMain.cbExpandedDirectionButtons.Value = 1 Then Periph3 = "2"
    If frmMain.cbExpandedDirectionButtons.Value = 1 And frmMain.cbYbutton.Value = 1 Then Periph3 = "3"
    If frmMain.cbZbutton.Value = 1 Then Periph3 = "4"
    If frmMain.cbZbutton.Value = 1 And frmMain.cbYbutton.Value = 1 Then Periph3 = "5"
    If frmMain.cbZbutton.Value = 1 And frmMain.cbExpandedDirectionButtons.Value = 1 Then Periph3 = "6"
    If frmMain.cbZbutton.Value = 1 And frmMain.cbExpandedDirectionButtons.Value = 1 And frmMain.cbYbutton.Value = 1 Then Periph3 = "7"
    If frmMain.cbAnalogRTrigger.Value = 1 Then Periph3 = "8"
    If frmMain.cbAnalogRTrigger.Value = 1 And frmMain.cbYbutton.Value = 1 Then Periph3 = "9"
    If frmMain.cbAnalogRTrigger.Value = 1 And frmMain.cbExpandedDirectionButtons.Value = 1 Then Periph3 = "A"
    If frmMain.cbAnalogRTrigger.Value = 1 And frmMain.cbExpandedDirectionButtons.Value = 1 And frmMain.cbYbutton.Value = 1 Then Periph3 = "B"
    If frmMain.cbAnalogRTrigger.Value = 1 And frmMain.cbZbutton.Value = 1 Then Periph3 = "C"
    If frmMain.cbAnalogRTrigger.Value = 1 And frmMain.cbZbutton.Value = 1 And frmMain.cbYbutton.Value = 1 Then Periph3 = "D"
    If frmMain.cbAnalogRTrigger.Value = 1 And frmMain.cbZbutton.Value = 1 And frmMain.cbExpandedDirectionButtons.Value = 1 Then Periph3 = "E"
    If frmMain.cbAnalogRTrigger.Value = 1 And frmMain.cbZbutton.Value = 1 And frmMain.cbExpandedDirectionButtons.Value = 1 And frmMain.cbYbutton.Value = 1 Then Periph3 = "F"
    
    Periph4 = "0"
    If frmMain.cbStartABDirections.Value = 1 Then Periph4 = "1"
    If frmMain.cbDbutton.Value = 1 Then Periph4 = "2"
    If frmMain.cbDbutton.Value = 1 And frmMain.cbStartABDirections.Value = 1 Then Periph4 = "3"
    If frmMain.cbCbutton.Value = 1 Then Periph4 = "4"
    If frmMain.cbCbutton.Value = 1 And frmMain.cbStartABDirections.Value = 1 Then Periph4 = "5"
    If frmMain.cbCbutton.Value = 1 And frmMain.cbDbutton.Value = 1 Then Periph4 = "6"
    If frmMain.cbCbutton.Value = 1 And frmMain.cbDbutton.Value = 1 And frmMain.cbStartABDirections.Value = 1 Then Periph4 = "7"
    If frmMain.cbXbutton.Value = 1 Then Periph4 = "8"
    If frmMain.cbXbutton.Value = 1 And frmMain.cbStartABDirections.Value = 1 Then Periph4 = "9"
    If frmMain.cbXbutton.Value = 1 And frmMain.cbDbutton.Value = 1 Then Periph4 = "A"
    If frmMain.cbXbutton.Value = 1 And frmMain.cbDbutton.Value = 1 And frmMain.cbStartABDirections.Value = 1 Then Periph4 = "B"
    If frmMain.cbXbutton.Value = 1 And frmMain.cbCbutton.Value = 1 Then Periph4 = "C"
    If frmMain.cbXbutton.Value = 1 And frmMain.cbCbutton.Value = 1 And frmMain.cbStartABDirections.Value = 1 Then Periph4 = "D"
    If frmMain.cbXbutton.Value = 1 And frmMain.cbCbutton.Value = 1 And frmMain.cbDbutton.Value = 1 Then Periph4 = "E"
    If frmMain.cbXbutton.Value = 1 And frmMain.cbCbutton.Value = 1 And frmMain.cbDbutton.Value = 1 And frmMain.cbStartABDirections.Value = 1 Then Periph4 = "F"
    
    Periph5 = "0"
    If frmMain.cbOtherExpansions.Value = 1 Then Periph5 = "1"
    If frmMain.cbMicrophone.Value = 1 Then Periph5 = "2"
    If frmMain.cbMicrophone.Value = 1 And frmMain.cbOtherExpansions.Value = 1 Then Periph5 = "3"
    If frmMain.cbPuruPuruPack.Value = 1 Then Periph5 = "4"
    If frmMain.cbPuruPuruPack.Value = 1 And frmMain.cbOtherExpansions.Value = 1 Then Periph5 = "5"
    If frmMain.cbPuruPuruPack.Value = 1 And frmMain.cbMicrophone.Value = 1 Then Periph5 = "6"
    If frmMain.cbPuruPuruPack.Value = 1 And frmMain.cbMicrophone.Value = 1 And frmMain.cbOtherExpansions.Value = 1 Then Periph5 = "7"
    If frmMain.cbMemoryCard.Value = 1 Then Periph5 = "8"
    If frmMain.cbMemoryCard.Value = 1 And frmMain.cbOtherExpansions.Value = 1 Then Periph5 = "9"
    If frmMain.cbMemoryCard.Value = 1 And frmMain.cbMicrophone.Value = 1 Then Periph5 = "A"
    If frmMain.cbMemoryCard.Value = 1 And frmMain.cbMicrophone.Value = 1 And frmMain.cbOtherExpansions.Value = 1 Then Periph5 = "B"
    If frmMain.cbMemoryCard.Value = 1 And frmMain.cbPuruPuruPack.Value = 1 Then Periph5 = "C"
    If frmMain.cbMemoryCard.Value = 1 And frmMain.cbPuruPuruPack.Value = 1 And frmMain.cbOtherExpansions.Value = 1 Then Periph5 = "D"
    If frmMain.cbMemoryCard.Value = 1 And frmMain.cbPuruPuruPack.Value = 1 And frmMain.cbMicrophone.Value = 1 Then Periph5 = "E"
    If frmMain.cbMemoryCard.Value = 1 And frmMain.cbPuruPuruPack.Value = 1 And frmMain.cbMicrophone.Value = 1 And frmMain.cbOtherExpansions.Value = 1 Then Periph5 = "F"
    
    Periph6 = "0"
    If frmMain.cbVGABoxSupport.Value = 1 Then Periph6 = "1"
    
    Periph7 = "0"
    If frmMain.cbUsesWindowsCE.Value = 1 Then Periph7 = "1"
    
    strPeripherals = Periph1 & Periph2 & Periph3 & Periph4 & Periph5 & Periph6 & Periph7
    strProductID = frmMain.txtProductID.Text
    strProductVer = "V" & frmMain.txtProductVersion.Text
    strReleaseDate = frmMain.txtReleaseYear.Text & frmMain.txtReleaseMonth.Text & frmMain.txtReleaseDay.Text
    strBootFilename = frmMain.cboBootFilename.Text
    strNameOfCompany = frmMain.txtNameOfCompany
    strNameOfSoftware = frmMain.txtNameOfSoftware

    EncodeMetaInfo = strHardwareID & _
                     strMakerID & _
                     strDeviceInfo & _
                     strAreaSymbols & _
                     strPeripherals & _
                     strProductID & _
                     strProductVer & _
                     strReleaseDate & _
                     strBootFilename & _
                     strNameOfCompany & _
                     strNameOfSoftware

    Exit Function

ErrorHandler:
    MsgBox "EncodeMetaInfo - modIP" & vbCrLf & vbCrLf & Err & " - " & Err.Description, vbCritical, "Error"

End Function

Public Function calcCRC() As String
    
On Error GoTo ErrorHandler

    Dim i As Long, c As Long, n As Long
    Dim ProductID As String * 10
    Dim ProductVersion As String * 6
    Dim buf() As Byte

    ProductID = frmMain.txtProductID.Text
    ProductVersion = "V" & frmMain.txtProductVersion.Text
    buf = StrConv(ProductID & ProductVersion, vbFromUnicode)
    
    n = &HFFFF&
    
    For i = 0 To 15
        n = n Xor (buf(i) * 256)
        For c = 0 To 7
            If n And &H8000& Then
                n = (n * 2) Xor &H1021
            Else
                n = (n * 2)
            End If
        Next c
    Next i
    
    calcCRC = Hex$(n And &HFFFF&)
    calcCRC = String$(4 - Len(calcCRC), "0") & calcCRC

    Exit Function

ErrorHandler:
    MsgBox "calcCRC - modIP" & vbCrLf & vbCrLf & Err & " - " & Err.Description, vbCritical, "Error"
  
End Function

