Attribute VB_Name = "modPublicFunctions"
Option Explicit

Private cReader    As New FL_CDReader

Public Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Private Declare Function PathFileExists Lib "shlwapi.dll" Alias "PathFileExistsA" (ByVal pszPath As String) As Long

Public Function AppPath() As String

    AppPath = App.Path
    If Right$(AppPath, 1) <> "\" Then AppPath$ = AppPath$ & "\"

End Function

Public Function FileExist(sFile As String) As Boolean

    FileExist = CStr(CBool(PathFileExists(sFile)))

End Function

Public Function StripNull(sFile As String) As String

    StripNull$ = Trim$(Replace$(sFile, Chr$(0), ""))

End Function

Public Function JustTitle(sFile As String) As String

    Dim i As Integer
    
    i = InStrRev(sFile, "\")
    
    If i Then
        JustTitle = Mid$(sFile, i + 1)
    Else
        JustTitle = sFile
    End If

End Function

Public Function JustExt(sFile As String) As String

    Dim i As Integer
    Dim title As String

    title = JustTitle$(sFile)
    i = InStrRev(title, ".")
    
    If i Then
        JustExt = LCase$(Mid$(title, i + 1))
    Else
        JustExt = ""
    End If

End Function

Public Function BytesInSectors(Number_of_Sectors As Long, Bytes_per_Sector As enm_SectorSizes) As Long

    BytesInSectors = Bytes_per_Sector * Number_of_Sectors

End Function

Public Function ExtractSector(driveid As String, LBA As Long, sectors As Integer, buf() As Byte) As enm_IPFormat

    Dim strIP As String
    ReDim buf((CLng(sectors) * CLng(2048)) - 1) As Byte
    Const intRetryCount As Integer = 3
    Dim i As Integer
    
    i = 0
    
Retry:
    If Not cReader.ReadSectorsLBA(driveid, CLng(LBA), sectors, buf) Then
        i = i + 1
        If i <> intRetryCount Then
            Debug.Print "Retrying ReadSectorsLBA..."
            GoTo Retry
        End If
        MsgBox "Could not read sector " & LBA
        Exit Function
    End If
    
    strIP = StrConv(buf, vbUnicode)
    
    'Check for IP.BIN\IP0000.BIN
    If Left(strIP, Len(IP_IDENTIFIER)) <> IP_IDENTIFIER Then Exit Function
    
    'IP.BIN\IP0000.BIN found, return which one
    If Mid(strIP, 2049, Len(IP_IDENTIFIER)) = IP_IDENTIFIER Then
        ExtractSector = FORMAT_IP0000
        Exit Function
    Else
        ExtractSector = FORMAT_IP
        Exit Function
    End If

End Function
